"""
    Stocks API For Digital Portals

    The Stocks API features a screener to search for equity instruments based on stock-specific parameters.  Parameters for up to three fiscal years might now be used in one request; data is available for the ten most recent completed fiscal years. Estimates are available for the current and two consecutive fiscal years. Search criteria also include benchmark-related attributes (beta, correlation, outperformance), and ESG parameters, based on FactSet’s Truvalue ESG scores.  A separate endpoint returns the possible values and value ranges for the parameters that the endpoint /stock/notation/screener/search accepts Application developers can request the values and value ranges only for a restricted set of notations that match predefined parameters. This functionality may be used to pre-fill the values and value ranges of the parameters of the /stock/notation/screener/search endpoint so that performing a search always leads to a non-empty set of notations.  The endpoint /stock/notation/ranking/intraday/list ranks stocks notations using intraday figures, for example to build a gainers/losers list.   Additional endpoints include end-of-day benchmark key figures, and selected fundamentals (as of end of fiscal year and with daily updates).  This API is fully integrated with the corresponding [Quotes API](https://developer.factset.com/api-catalog/quotes-api-digital-portals), allowing access to detailed price and performance information of instruments, as well as basic security identifier cross-reference. For direct access to price histories, please refer to the [Time Series API for Digital Portals](https://developer.factset.com/api-catalog/time-series-api-digital-portals).  Similar criteria based screener APIs exist for fixed income instruments and securitized derivatives: See the [Bonds API](https://developer.factset.com/api-catalog/bonds-api-digital-portals) and the [Securitized Derivatives API](https://developer.factset.com/api-catalog/securitized-derivatives-api-digital-portals) for details.  See also the recipe [\"Enrich Your Digital Portal with Flexible Equity Screening\"](https://developer.factset.com/recipe-catalog/enrich-your-digital-portal-flexible-equity-screening).   # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.StocksAPIforDigitalPortals.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.StocksAPIforDigitalPortals.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.StocksAPIforDigitalPortals.model.attributes_member import AttributesMember
    from fds.sdk.StocksAPIforDigitalPortals.model.language_member import LanguageMember
    from fds.sdk.StocksAPIforDigitalPortals.model.post_stock_notation_screener_search_request_meta_pagination import PostStockNotationScreenerSearchRequestMetaPagination
    globals()['AttributesMember'] = AttributesMember
    globals()['LanguageMember'] = LanguageMember
    globals()['PostStockNotationScreenerSearchRequestMetaPagination'] = PostStockNotationScreenerSearchRequestMetaPagination


class PostStockNotationScreenerSearchRequestMeta(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('sort',): {
            'VALUEUNIT.CODE': "valueUnit.code",
            '-VALUEUNIT.CODE': "-valueUnit.code",
            'MARKET.NAME': "market.name",
            '-MARKET.NAME': "-market.name",
            'SYMBOL': "symbol",
            '-SYMBOL': "-symbol",
            'INSTRUMENT.NAME': "instrument.name",
            '-INSTRUMENT.NAME': "-instrument.name",
            'INSTRUMENT.SHORTNAME': "instrument.shortName",
            '-INSTRUMENT.SHORTNAME': "-instrument.shortName",
            'INSTRUMENT.STOCKTYPE': "instrument.stockType",
            '-INSTRUMENT.STOCKTYPE': "-instrument.stockType",
            'INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL1.NAME': "instrument.industryClassification.rbics.level1.name",
            '-INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL1.NAME': "-instrument.industryClassification.rbics.level1.name",
            'INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL2.NAME': "instrument.industryClassification.rbics.level2.name",
            '-INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL2.NAME': "-instrument.industryClassification.rbics.level2.name",
            'INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL3.NAME': "instrument.industryClassification.rbics.level3.name",
            '-INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL3.NAME': "-instrument.industryClassification.rbics.level3.name",
            'INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL4.NAME': "instrument.industryClassification.rbics.level4.name",
            '-INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL4.NAME': "-instrument.industryClassification.rbics.level4.name",
            'INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL5.NAME': "instrument.industryClassification.rbics.level5.name",
            '-INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL5.NAME': "-instrument.industryClassification.rbics.level5.name",
            'INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL6.NAME': "instrument.industryClassification.rbics.level6.name",
            '-INSTRUMENT.INDUSTRYCLASSIFICATION.RBICS.LEVEL6.NAME': "-instrument.industryClassification.rbics.level6.name",
            'INSTRUMENT.COMPANY.NAME': "instrument.company.name",
            '-INSTRUMENT.COMPANY.NAME': "-instrument.company.name",
            'INSTRUMENT.COMPANY.COUNTRY.NAME': "instrument.company.country.name",
            '-INSTRUMENT.COMPANY.COUNTRY.NAME': "-instrument.company.country.name",
            'ESG.TRUVALUELABS.SASB.ALLCATEGORIES.INSIGHT': "esg.truvalueLabs.sasb.allCategories.insight",
            '-ESG.TRUVALUELABS.SASB.ALLCATEGORIES.INSIGHT': "-esg.truvalueLabs.sasb.allCategories.insight",
            'ESG.TRUVALUELABS.SASB.ALLCATEGORIES.MOMENTUM': "esg.truvalueLabs.sasb.allCategories.momentum",
            '-ESG.TRUVALUELABS.SASB.ALLCATEGORIES.MOMENTUM': "-esg.truvalueLabs.sasb.allCategories.momentum",
            'ESG.TRUVALUELABS.SASB.ALLCATEGORIES.RANKING': "esg.truvalueLabs.sasb.allCategories.ranking",
            '-ESG.TRUVALUELABS.SASB.ALLCATEGORIES.RANKING': "-esg.truvalueLabs.sasb.allCategories.ranking",
            'ESG.TRUVALUELABS.SASB.MATERIALITY.INSIGHT': "esg.truvalueLabs.sasb.materiality.insight",
            '-ESG.TRUVALUELABS.SASB.MATERIALITY.INSIGHT': "-esg.truvalueLabs.sasb.materiality.insight",
            'ESG.TRUVALUELABS.SASB.MATERIALITY.MOMENTUM': "esg.truvalueLabs.sasb.materiality.momentum",
            '-ESG.TRUVALUELABS.SASB.MATERIALITY.MOMENTUM': "-esg.truvalueLabs.sasb.materiality.momentum",
            'ESG.TRUVALUELABS.SASB.MATERIALITY.RANKING': "esg.truvalueLabs.sasb.materiality.ranking",
            '-ESG.TRUVALUELABS.SASB.MATERIALITY.RANKING': "-esg.truvalueLabs.sasb.materiality.ranking",
            'ESG.TRUVALUELABS.SDG.IMPACT.INSIGHT': "esg.truvalueLabs.sdg.impact.insight",
            '-ESG.TRUVALUELABS.SDG.IMPACT.INSIGHT': "-esg.truvalueLabs.sdg.impact.insight",
            'ESG.TRUVALUELABS.SDG.IMPACT.MOMENTUM': "esg.truvalueLabs.sdg.impact.momentum",
            '-ESG.TRUVALUELABS.SDG.IMPACT.MOMENTUM': "-esg.truvalueLabs.sdg.impact.momentum",
            'CURRENTKEYFIGURES.COMPANY.SHARESOUTSTANDING': "currentKeyFigures.company.sharesOutstanding",
            '-CURRENTKEYFIGURES.COMPANY.SHARESOUTSTANDING': "-currentKeyFigures.company.sharesOutstanding",
            'CURRENTKEYFIGURES.COMPANY.FREEFLOAT': "currentKeyFigures.company.freeFloat",
            '-CURRENTKEYFIGURES.COMPANY.FREEFLOAT': "-currentKeyFigures.company.freeFloat",
            'CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.MARKETCAPITALIZATIONSHARESOUTSTANDING': "currentKeyFigures.company.currencyDependent.marketCapitalizationSharesOutstanding",
            '-CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.MARKETCAPITALIZATIONSHARESOUTSTANDING': "-currentKeyFigures.company.currencyDependent.marketCapitalizationSharesOutstanding",
            'CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.PERSHARE.EARNINGS': "currentKeyFigures.company.currencyDependent.perShare.earnings",
            '-CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.PERSHARE.EARNINGS': "-currentKeyFigures.company.currencyDependent.perShare.earnings",
            'CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.PERSHARE.BOOKVALUE': "currentKeyFigures.company.currencyDependent.perShare.bookValue",
            '-CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.PERSHARE.BOOKVALUE': "-currentKeyFigures.company.currencyDependent.perShare.bookValue",
            'CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.PERSHARE.CASHFLOW': "currentKeyFigures.company.currencyDependent.perShare.cashFlow",
            '-CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.PERSHARE.CASHFLOW': "-currentKeyFigures.company.currencyDependent.perShare.cashFlow",
            'CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.PERSHARE.SALES': "currentKeyFigures.company.currencyDependent.perShare.sales",
            '-CURRENTKEYFIGURES.COMPANY.CURRENCYDEPENDENT.PERSHARE.SALES': "-currentKeyFigures.company.currencyDependent.perShare.sales",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.SHARESOUTSTANDING': "currentKeyFigures.shareInstrument.sharesOutstanding",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.SHARESOUTSTANDING': "-currentKeyFigures.shareInstrument.sharesOutstanding",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.FREEFLOAT': "currentKeyFigures.shareInstrument.freeFloat",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.FREEFLOAT': "-currentKeyFigures.shareInstrument.freeFloat",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.PRICEEARNINGS': "currentKeyFigures.shareInstrument.ratios.priceEarnings",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.PRICEEARNINGS': "-currentKeyFigures.shareInstrument.ratios.priceEarnings",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.PRICEBOOKVALUE': "currentKeyFigures.shareInstrument.ratios.priceBookValue",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.PRICEBOOKVALUE': "-currentKeyFigures.shareInstrument.ratios.priceBookValue",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.PRICECASHFLOW': "currentKeyFigures.shareInstrument.ratios.priceCashFlow",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.PRICECASHFLOW': "-currentKeyFigures.shareInstrument.ratios.priceCashFlow",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.PRICESALES': "currentKeyFigures.shareInstrument.ratios.priceSales",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.PRICESALES': "-currentKeyFigures.shareInstrument.ratios.priceSales",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.DIVIDENDYIELD': "currentKeyFigures.shareInstrument.ratios.dividendYield",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.DIVIDENDYIELD': "-currentKeyFigures.shareInstrument.ratios.dividendYield",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.EARNINGSYIELD': "currentKeyFigures.shareInstrument.ratios.earningsYield",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.RATIOS.EARNINGSYIELD': "-currentKeyFigures.shareInstrument.ratios.earningsYield",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.CURRENCYDEPENDENT.MARKETCAPITALIZATIONSHARESOUTSTANDING': "currentKeyFigures.shareInstrument.currencyDependent.marketCapitalizationSharesOutstanding",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.CURRENCYDEPENDENT.MARKETCAPITALIZATIONSHARESOUTSTANDING': "-currentKeyFigures.shareInstrument.currencyDependent.marketCapitalizationSharesOutstanding",
            'CURRENTKEYFIGURES.SHAREINSTRUMENT.CURRENCYDEPENDENT.PERSHARE.DIVIDEND': "currentKeyFigures.shareInstrument.currencyDependent.perShare.dividend",
            '-CURRENTKEYFIGURES.SHAREINSTRUMENT.CURRENCYDEPENDENT.PERSHARE.DIVIDEND': "-currentKeyFigures.shareInstrument.currencyDependent.perShare.dividend",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.CURRENCY.ISOCODE': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.currency.isoCode",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.CURRENCY.ISOCODE': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.currency.isoCode",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.MARKETCAPITALIZATION': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.marketCapitalization",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.MARKETCAPITALIZATION': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.marketCapitalization",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBIT': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.ebit",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBIT': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.ebit",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBITDA': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.ebitda",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBITDA': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.ebitda",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.SALES': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.sales",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.SALES': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.sales",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.RECURRINGDILUTEDEARNINGS': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.recurringDilutedEarnings",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.RECURRINGDILUTEDEARNINGS': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.recurringDilutedEarnings",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.DIVIDENDS': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.dividends",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.DIVIDENDS': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.dividends",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.BOOKVALUE': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.bookValue",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.BOOKVALUE': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.bookValue",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.CASHFLOW': "reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.cashFlow",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.CASHFLOW': "-reportedKeyFigures.firstFiscalYear.currencyDependentKeyFigures.perShare.cashFlow",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.EBITMARGIN': "reportedKeyFigures.firstFiscalYear.ebitMargin",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.EBITMARGIN': "-reportedKeyFigures.firstFiscalYear.ebitMargin",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.EBITDAMARGIN': "reportedKeyFigures.firstFiscalYear.ebitdaMargin",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.EBITDAMARGIN': "-reportedKeyFigures.firstFiscalYear.ebitdaMargin",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.NETINCOMEMARGIN': "reportedKeyFigures.firstFiscalYear.netIncomeMargin",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.NETINCOMEMARGIN': "-reportedKeyFigures.firstFiscalYear.netIncomeMargin",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.GROSSINCOMEMARGIN': "reportedKeyFigures.firstFiscalYear.grossIncomeMargin",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.GROSSINCOMEMARGIN': "-reportedKeyFigures.firstFiscalYear.grossIncomeMargin",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.OPERATINGMARGIN': "reportedKeyFigures.firstFiscalYear.operatingMargin",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.OPERATINGMARGIN': "-reportedKeyFigures.firstFiscalYear.operatingMargin",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RETURNONASSETS': "reportedKeyFigures.firstFiscalYear.returnOnAssets",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RETURNONASSETS': "-reportedKeyFigures.firstFiscalYear.returnOnAssets",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RETURNONEQUITY': "reportedKeyFigures.firstFiscalYear.returnOnEquity",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RETURNONEQUITY': "-reportedKeyFigures.firstFiscalYear.returnOnEquity",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICESALES': "reportedKeyFigures.firstFiscalYear.ratios.priceSales",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICESALES': "-reportedKeyFigures.firstFiscalYear.ratios.priceSales",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICEEARNINGS': "reportedKeyFigures.firstFiscalYear.ratios.priceEarnings",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICEEARNINGS': "-reportedKeyFigures.firstFiscalYear.ratios.priceEarnings",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICEBOOKVALUE': "reportedKeyFigures.firstFiscalYear.ratios.priceBookValue",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICEBOOKVALUE': "-reportedKeyFigures.firstFiscalYear.ratios.priceBookValue",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICECASHFLOW': "reportedKeyFigures.firstFiscalYear.ratios.priceCashFlow",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICECASHFLOW': "-reportedKeyFigures.firstFiscalYear.ratios.priceCashFlow",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICEFREECASHFLOW': "reportedKeyFigures.firstFiscalYear.ratios.priceFreeCashFlow",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.PRICEFREECASHFLOW': "-reportedKeyFigures.firstFiscalYear.ratios.priceFreeCashFlow",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.DIVIDENDYIELD': "reportedKeyFigures.firstFiscalYear.ratios.dividendYield",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.DIVIDENDYIELD': "-reportedKeyFigures.firstFiscalYear.ratios.dividendYield",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT': "reportedKeyFigures.firstFiscalYear.ratios.enterpriseValueEbit",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT': "-reportedKeyFigures.firstFiscalYear.ratios.enterpriseValueEbit",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA': "reportedKeyFigures.firstFiscalYear.ratios.enterpriseValueEbitda",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA': "-reportedKeyFigures.firstFiscalYear.ratios.enterpriseValueEbitda",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUESALES': "reportedKeyFigures.firstFiscalYear.ratios.enterpriseValueSales",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUESALES': "-reportedKeyFigures.firstFiscalYear.ratios.enterpriseValueSales",
            'REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.DEBTEQUITY': "reportedKeyFigures.firstFiscalYear.ratios.debtEquity",
            '-REPORTEDKEYFIGURES.FIRSTFISCALYEAR.RATIOS.DEBTEQUITY': "-reportedKeyFigures.firstFiscalYear.ratios.debtEquity",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.CURRENCY.ISOCODE': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.currency.isoCode",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.CURRENCY.ISOCODE': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.currency.isoCode",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.MARKETCAPITALIZATION': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.marketCapitalization",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.MARKETCAPITALIZATION': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.marketCapitalization",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBIT': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.ebit",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBIT': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.ebit",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBITDA': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.ebitda",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBITDA': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.ebitda",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.SALES': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.sales",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.SALES': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.sales",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.RECURRINGDILUTEDEARNINGS': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.recurringDilutedEarnings",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.RECURRINGDILUTEDEARNINGS': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.recurringDilutedEarnings",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.DIVIDENDS': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.dividends",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.DIVIDENDS': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.dividends",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.BOOKVALUE': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.bookValue",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.BOOKVALUE': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.bookValue",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.CASHFLOW': "reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.cashFlow",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.CASHFLOW': "-reportedKeyFigures.secondFiscalYear.currencyDependentKeyFigures.perShare.cashFlow",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.EBITMARGIN': "reportedKeyFigures.secondFiscalYear.ebitMargin",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.EBITMARGIN': "-reportedKeyFigures.secondFiscalYear.ebitMargin",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.EBITDAMARGIN': "reportedKeyFigures.secondFiscalYear.ebitdaMargin",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.EBITDAMARGIN': "-reportedKeyFigures.secondFiscalYear.ebitdaMargin",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.NETINCOMEMARGIN': "reportedKeyFigures.secondFiscalYear.netIncomeMargin",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.NETINCOMEMARGIN': "-reportedKeyFigures.secondFiscalYear.netIncomeMargin",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.GROSSINCOMEMARGIN': "reportedKeyFigures.secondFiscalYear.grossIncomeMargin",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.GROSSINCOMEMARGIN': "-reportedKeyFigures.secondFiscalYear.grossIncomeMargin",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.OPERATINGMARGIN': "reportedKeyFigures.secondFiscalYear.operatingMargin",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.OPERATINGMARGIN': "-reportedKeyFigures.secondFiscalYear.operatingMargin",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RETURNONASSETS': "reportedKeyFigures.secondFiscalYear.returnOnAssets",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RETURNONASSETS': "-reportedKeyFigures.secondFiscalYear.returnOnAssets",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RETURNONEQUITY': "reportedKeyFigures.secondFiscalYear.returnOnEquity",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RETURNONEQUITY': "-reportedKeyFigures.secondFiscalYear.returnOnEquity",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICESALES': "reportedKeyFigures.secondFiscalYear.ratios.priceSales",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICESALES': "-reportedKeyFigures.secondFiscalYear.ratios.priceSales",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICEEARNINGS': "reportedKeyFigures.secondFiscalYear.ratios.priceEarnings",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICEEARNINGS': "-reportedKeyFigures.secondFiscalYear.ratios.priceEarnings",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICEBOOKVALUE': "reportedKeyFigures.secondFiscalYear.ratios.priceBookValue",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICEBOOKVALUE': "-reportedKeyFigures.secondFiscalYear.ratios.priceBookValue",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICECASHFLOW': "reportedKeyFigures.secondFiscalYear.ratios.priceCashFlow",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICECASHFLOW': "-reportedKeyFigures.secondFiscalYear.ratios.priceCashFlow",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICEFREECASHFLOW': "reportedKeyFigures.secondFiscalYear.ratios.priceFreeCashFlow",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.PRICEFREECASHFLOW': "-reportedKeyFigures.secondFiscalYear.ratios.priceFreeCashFlow",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.DIVIDENDYIELD': "reportedKeyFigures.secondFiscalYear.ratios.dividendYield",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.DIVIDENDYIELD': "-reportedKeyFigures.secondFiscalYear.ratios.dividendYield",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT': "reportedKeyFigures.secondFiscalYear.ratios.enterpriseValueEbit",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT': "-reportedKeyFigures.secondFiscalYear.ratios.enterpriseValueEbit",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA': "reportedKeyFigures.secondFiscalYear.ratios.enterpriseValueEbitda",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA': "-reportedKeyFigures.secondFiscalYear.ratios.enterpriseValueEbitda",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUESALES': "reportedKeyFigures.secondFiscalYear.ratios.enterpriseValueSales",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUESALES': "-reportedKeyFigures.secondFiscalYear.ratios.enterpriseValueSales",
            'REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.DEBTEQUITY': "reportedKeyFigures.secondFiscalYear.ratios.debtEquity",
            '-REPORTEDKEYFIGURES.SECONDFISCALYEAR.RATIOS.DEBTEQUITY': "-reportedKeyFigures.secondFiscalYear.ratios.debtEquity",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.CURRENCY.ISOCODE': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.currency.isoCode",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.CURRENCY.ISOCODE': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.currency.isoCode",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.MARKETCAPITALIZATION': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.marketCapitalization",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.MARKETCAPITALIZATION': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.marketCapitalization",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBIT': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.ebit",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBIT': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.ebit",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBITDA': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.ebitda",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.EBITDA': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.ebitda",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.SALES': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.sales",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.SALES': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.sales",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.RECURRINGDILUTEDEARNINGS': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.recurringDilutedEarnings",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.RECURRINGDILUTEDEARNINGS': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.recurringDilutedEarnings",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.DIVIDENDS': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.dividends",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.DIVIDENDS': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.dividends",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.BOOKVALUE': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.bookValue",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.BOOKVALUE': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.bookValue",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.CASHFLOW': "reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.cashFlow",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.CURRENCYDEPENDENTKEYFIGURES.PERSHARE.CASHFLOW': "-reportedKeyFigures.thirdFiscalYear.currencyDependentKeyFigures.perShare.cashFlow",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.EBITMARGIN': "reportedKeyFigures.thirdFiscalYear.ebitMargin",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.EBITMARGIN': "-reportedKeyFigures.thirdFiscalYear.ebitMargin",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.EBITDAMARGIN': "reportedKeyFigures.thirdFiscalYear.ebitdaMargin",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.EBITDAMARGIN': "-reportedKeyFigures.thirdFiscalYear.ebitdaMargin",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.NETINCOMEMARGIN': "reportedKeyFigures.thirdFiscalYear.netIncomeMargin",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.NETINCOMEMARGIN': "-reportedKeyFigures.thirdFiscalYear.netIncomeMargin",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.GROSSINCOMEMARGIN': "reportedKeyFigures.thirdFiscalYear.grossIncomeMargin",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.GROSSINCOMEMARGIN': "-reportedKeyFigures.thirdFiscalYear.grossIncomeMargin",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.OPERATINGMARGIN': "reportedKeyFigures.thirdFiscalYear.operatingMargin",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.OPERATINGMARGIN': "-reportedKeyFigures.thirdFiscalYear.operatingMargin",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RETURNONASSETS': "reportedKeyFigures.thirdFiscalYear.returnOnAssets",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RETURNONASSETS': "-reportedKeyFigures.thirdFiscalYear.returnOnAssets",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RETURNONEQUITY': "reportedKeyFigures.thirdFiscalYear.returnOnEquity",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RETURNONEQUITY': "-reportedKeyFigures.thirdFiscalYear.returnOnEquity",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICESALES': "reportedKeyFigures.thirdFiscalYear.ratios.priceSales",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICESALES': "-reportedKeyFigures.thirdFiscalYear.ratios.priceSales",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICEEARNINGS': "reportedKeyFigures.thirdFiscalYear.ratios.priceEarnings",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICEEARNINGS': "-reportedKeyFigures.thirdFiscalYear.ratios.priceEarnings",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICEBOOKVALUE': "reportedKeyFigures.thirdFiscalYear.ratios.priceBookValue",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICEBOOKVALUE': "-reportedKeyFigures.thirdFiscalYear.ratios.priceBookValue",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICECASHFLOW': "reportedKeyFigures.thirdFiscalYear.ratios.priceCashFlow",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICECASHFLOW': "-reportedKeyFigures.thirdFiscalYear.ratios.priceCashFlow",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICEFREECASHFLOW': "reportedKeyFigures.thirdFiscalYear.ratios.priceFreeCashFlow",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.PRICEFREECASHFLOW': "-reportedKeyFigures.thirdFiscalYear.ratios.priceFreeCashFlow",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.DIVIDENDYIELD': "reportedKeyFigures.thirdFiscalYear.ratios.dividendYield",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.DIVIDENDYIELD': "-reportedKeyFigures.thirdFiscalYear.ratios.dividendYield",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT': "reportedKeyFigures.thirdFiscalYear.ratios.enterpriseValueEbit",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT': "-reportedKeyFigures.thirdFiscalYear.ratios.enterpriseValueEbit",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA': "reportedKeyFigures.thirdFiscalYear.ratios.enterpriseValueEbitda",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA': "-reportedKeyFigures.thirdFiscalYear.ratios.enterpriseValueEbitda",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUESALES': "reportedKeyFigures.thirdFiscalYear.ratios.enterpriseValueSales",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUESALES': "-reportedKeyFigures.thirdFiscalYear.ratios.enterpriseValueSales",
            'REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.DEBTEQUITY': "reportedKeyFigures.thirdFiscalYear.ratios.debtEquity",
            '-REPORTEDKEYFIGURES.THIRDFISCALYEAR.RATIOS.DEBTEQUITY': "-reportedKeyFigures.thirdFiscalYear.ratios.debtEquity",
            'BENCHMARK.BETA.WEEK1': "benchmark.beta.week1",
            '-BENCHMARK.BETA.WEEK1': "-benchmark.beta.week1",
            'BENCHMARK.BETA.MONTH1': "benchmark.beta.month1",
            '-BENCHMARK.BETA.MONTH1': "-benchmark.beta.month1",
            'BENCHMARK.BETA.MONTHS3': "benchmark.beta.months3",
            '-BENCHMARK.BETA.MONTHS3': "-benchmark.beta.months3",
            'BENCHMARK.BETA.MONTHS6': "benchmark.beta.months6",
            '-BENCHMARK.BETA.MONTHS6': "-benchmark.beta.months6",
            'BENCHMARK.BETA.YEAR1': "benchmark.beta.year1",
            '-BENCHMARK.BETA.YEAR1': "-benchmark.beta.year1",
            'BENCHMARK.BETA.YEARS3': "benchmark.beta.years3",
            '-BENCHMARK.BETA.YEARS3': "-benchmark.beta.years3",
            'BENCHMARK.BETA.YEARS5': "benchmark.beta.years5",
            '-BENCHMARK.BETA.YEARS5': "-benchmark.beta.years5",
            'BENCHMARK.CORRELATION.WEEK1': "benchmark.correlation.week1",
            '-BENCHMARK.CORRELATION.WEEK1': "-benchmark.correlation.week1",
            'BENCHMARK.CORRELATION.MONTH1': "benchmark.correlation.month1",
            '-BENCHMARK.CORRELATION.MONTH1': "-benchmark.correlation.month1",
            'BENCHMARK.CORRELATION.MONTHS3': "benchmark.correlation.months3",
            '-BENCHMARK.CORRELATION.MONTHS3': "-benchmark.correlation.months3",
            'BENCHMARK.CORRELATION.MONTHS6': "benchmark.correlation.months6",
            '-BENCHMARK.CORRELATION.MONTHS6': "-benchmark.correlation.months6",
            'BENCHMARK.CORRELATION.YEAR1': "benchmark.correlation.year1",
            '-BENCHMARK.CORRELATION.YEAR1': "-benchmark.correlation.year1",
            'BENCHMARK.CORRELATION.YEARS3': "benchmark.correlation.years3",
            '-BENCHMARK.CORRELATION.YEARS3': "-benchmark.correlation.years3",
            'BENCHMARK.CORRELATION.YEARS5': "benchmark.correlation.years5",
            '-BENCHMARK.CORRELATION.YEARS5': "-benchmark.correlation.years5",
            'BENCHMARK.OUTPERFORMANCE.WEEK1': "benchmark.outperformance.week1",
            '-BENCHMARK.OUTPERFORMANCE.WEEK1': "-benchmark.outperformance.week1",
            'BENCHMARK.OUTPERFORMANCE.MONTH1': "benchmark.outperformance.month1",
            '-BENCHMARK.OUTPERFORMANCE.MONTH1': "-benchmark.outperformance.month1",
            'BENCHMARK.OUTPERFORMANCE.MONTHS3': "benchmark.outperformance.months3",
            '-BENCHMARK.OUTPERFORMANCE.MONTHS3': "-benchmark.outperformance.months3",
            'BENCHMARK.OUTPERFORMANCE.MONTHS6': "benchmark.outperformance.months6",
            '-BENCHMARK.OUTPERFORMANCE.MONTHS6': "-benchmark.outperformance.months6",
            'BENCHMARK.OUTPERFORMANCE.YEAR1': "benchmark.outperformance.year1",
            '-BENCHMARK.OUTPERFORMANCE.YEAR1': "-benchmark.outperformance.year1",
            'BENCHMARK.OUTPERFORMANCE.YEARS3': "benchmark.outperformance.years3",
            '-BENCHMARK.OUTPERFORMANCE.YEARS3': "-benchmark.outperformance.years3",
            'BENCHMARK.OUTPERFORMANCE.YEARS5': "benchmark.outperformance.years5",
            '-BENCHMARK.OUTPERFORMANCE.YEARS5': "-benchmark.outperformance.years5",
            'PERFORMANCE.INTRADAY': "performance.intraday",
            '-PERFORMANCE.INTRADAY': "-performance.intraday",
            'PERFORMANCE.ENDOFDAY.DAY1': "performance.endOfDay.day1",
            '-PERFORMANCE.ENDOFDAY.DAY1': "-performance.endOfDay.day1",
            'PERFORMANCE.ENDOFDAY.WEEK1': "performance.endOfDay.week1",
            '-PERFORMANCE.ENDOFDAY.WEEK1': "-performance.endOfDay.week1",
            'PERFORMANCE.ENDOFDAY.MONTH1': "performance.endOfDay.month1",
            '-PERFORMANCE.ENDOFDAY.MONTH1': "-performance.endOfDay.month1",
            'PERFORMANCE.ENDOFDAY.MONTHS3': "performance.endOfDay.months3",
            '-PERFORMANCE.ENDOFDAY.MONTHS3': "-performance.endOfDay.months3",
            'PERFORMANCE.ENDOFDAY.MONTHS6': "performance.endOfDay.months6",
            '-PERFORMANCE.ENDOFDAY.MONTHS6': "-performance.endOfDay.months6",
            'PERFORMANCE.ENDOFDAY.YEAR1': "performance.endOfDay.year1",
            '-PERFORMANCE.ENDOFDAY.YEAR1': "-performance.endOfDay.year1",
            'PERFORMANCE.ENDOFDAY.YEARS3': "performance.endOfDay.years3",
            '-PERFORMANCE.ENDOFDAY.YEARS3': "-performance.endOfDay.years3",
            'PERFORMANCE.ENDOFDAY.YEARS5': "performance.endOfDay.years5",
            '-PERFORMANCE.ENDOFDAY.YEARS5': "-performance.endOfDay.years5",
            'PERFORMANCE.ENDOFDAY.YEARTODATE': "performance.endOfDay.yearToDate",
            '-PERFORMANCE.ENDOFDAY.YEARTODATE': "-performance.endOfDay.yearToDate",
            'VOLATILITY.WEEK1': "volatility.week1",
            '-VOLATILITY.WEEK1': "-volatility.week1",
            'VOLATILITY.MONTH1': "volatility.month1",
            '-VOLATILITY.MONTH1': "-volatility.month1",
            'VOLATILITY.MONTHS3': "volatility.months3",
            '-VOLATILITY.MONTHS3': "-volatility.months3",
            'VOLATILITY.MONTHS6': "volatility.months6",
            '-VOLATILITY.MONTHS6': "-volatility.months6",
            'VOLATILITY.YEAR1': "volatility.year1",
            '-VOLATILITY.YEAR1': "-volatility.year1",
            'VOLATILITY.YEARS3': "volatility.years3",
            '-VOLATILITY.YEARS3': "-volatility.years3",
            'VOLATILITY.YEARS5': "volatility.years5",
            '-VOLATILITY.YEARS5': "-volatility.years5",
            'VOLATILITY.YEARTODATE': "volatility.yearToDate",
            '-VOLATILITY.YEARTODATE': "-volatility.yearToDate",
            'TRADINGVALUE.AVERAGE.DAYS5': "tradingValue.average.days5",
            '-TRADINGVALUE.AVERAGE.DAYS5': "-tradingValue.average.days5",
            'TRADINGVALUE.AVERAGE.DAYS30': "tradingValue.average.days30",
            '-TRADINGVALUE.AVERAGE.DAYS30': "-tradingValue.average.days30",
            'SIMPLEMOVINGAVERAGE.TRADINGDAYSSINCECROSSOVER.SMA20VS50.NUMBERDAYS': "simpleMovingAverage.tradingDaysSinceCrossover.sma20vs50.numberDays",
            '-SIMPLEMOVINGAVERAGE.TRADINGDAYSSINCECROSSOVER.SMA20VS50.NUMBERDAYS': "-simpleMovingAverage.tradingDaysSinceCrossover.sma20vs50.numberDays",
            'SIMPLEMOVINGAVERAGE.TRADINGDAYSSINCECROSSOVER.SMA20VS50.DIRECTION': "simpleMovingAverage.tradingDaysSinceCrossover.sma20vs50.direction",
            '-SIMPLEMOVINGAVERAGE.TRADINGDAYSSINCECROSSOVER.SMA20VS50.DIRECTION': "-simpleMovingAverage.tradingDaysSinceCrossover.sma20vs50.direction",
            'SIMPLEMOVINGAVERAGE.TRADINGDAYSSINCECROSSOVER.SMA50VS200.NUMBERDAYS': "simpleMovingAverage.tradingDaysSinceCrossover.sma50vs200.numberDays",
            '-SIMPLEMOVINGAVERAGE.TRADINGDAYSSINCECROSSOVER.SMA50VS200.NUMBERDAYS': "-simpleMovingAverage.tradingDaysSinceCrossover.sma50vs200.numberDays",
            'SIMPLEMOVINGAVERAGE.TRADINGDAYSSINCECROSSOVER.SMA50VS200.DIRECTION': "simpleMovingAverage.tradingDaysSinceCrossover.sma50vs200.direction",
            '-SIMPLEMOVINGAVERAGE.TRADINGDAYSSINCECROSSOVER.SMA50VS200.DIRECTION': "-simpleMovingAverage.tradingDaysSinceCrossover.sma50vs200.direction",
            'RSIWILDER.DAYS14': "rsiWilder.days14",
            '-RSIWILDER.DAYS14': "-rsiWilder.days14",
            'RECOMMENDATION.COUNTS.TOTAL': "recommendation.counts.total",
            '-RECOMMENDATION.COUNTS.TOTAL': "-recommendation.counts.total",
            'RECOMMENDATION.CONSENSUS.CHANGE.WEEK1': "recommendation.consensus.change.week1",
            '-RECOMMENDATION.CONSENSUS.CHANGE.WEEK1': "-recommendation.consensus.change.week1",
            'RECOMMENDATION.CONSENSUS.CHANGE.MONTH1': "recommendation.consensus.change.month1",
            '-RECOMMENDATION.CONSENSUS.CHANGE.MONTH1': "-recommendation.consensus.change.month1",
            'RECOMMENDATION.CONSENSUS.CHANGE.MONTHS3': "recommendation.consensus.change.months3",
            '-RECOMMENDATION.CONSENSUS.CHANGE.MONTHS3': "-recommendation.consensus.change.months3",
            'RECOMMENDATION.CONSENSUS.CHANGE.MONTHS6': "recommendation.consensus.change.months6",
            '-RECOMMENDATION.CONSENSUS.CHANGE.MONTHS6': "-recommendation.consensus.change.months6",
            'RECOMMENDATION.CONSENSUS.CHANGE.YEAR1': "recommendation.consensus.change.year1",
            '-RECOMMENDATION.CONSENSUS.CHANGE.YEAR1': "-recommendation.consensus.change.year1",
            'ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.CURRENCY.ISOCODE': "estimates.firstFiscalYear.currencyDependentEstimates.currency.isoCode",
            '-ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.CURRENCY.ISOCODE': "-estimates.firstFiscalYear.currencyDependentEstimates.currency.isoCode",
            'ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBIT.MEAN': "estimates.firstFiscalYear.currencyDependentEstimates.ebit.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBIT.MEAN': "-estimates.firstFiscalYear.currencyDependentEstimates.ebit.mean",
            'ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBITDA.MEAN': "estimates.firstFiscalYear.currencyDependentEstimates.ebitda.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBITDA.MEAN': "-estimates.firstFiscalYear.currencyDependentEstimates.ebitda.mean",
            'ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.SALES.MEAN': "estimates.firstFiscalYear.currencyDependentEstimates.perShare.sales.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.SALES.MEAN': "-estimates.firstFiscalYear.currencyDependentEstimates.perShare.sales.mean",
            'ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.EARNINGS.MEAN': "estimates.firstFiscalYear.currencyDependentEstimates.perShare.earnings.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.EARNINGS.MEAN': "-estimates.firstFiscalYear.currencyDependentEstimates.perShare.earnings.mean",
            'ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.DIVIDENDS.MEAN': "estimates.firstFiscalYear.currencyDependentEstimates.perShare.dividends.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.DIVIDENDS.MEAN': "-estimates.firstFiscalYear.currencyDependentEstimates.perShare.dividends.mean",
            'ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.CASHFLOW.MEAN': "estimates.firstFiscalYear.currencyDependentEstimates.perShare.cashFlow.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.CASHFLOW.MEAN': "-estimates.firstFiscalYear.currencyDependentEstimates.perShare.cashFlow.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RETURNONASSETS.MEAN': "estimates.firstFiscalYear.returnOnAssets.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RETURNONASSETS.MEAN': "-estimates.firstFiscalYear.returnOnAssets.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RETURNONEQUITY.MEAN': "estimates.firstFiscalYear.returnOnEquity.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RETURNONEQUITY.MEAN': "-estimates.firstFiscalYear.returnOnEquity.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICESALES.MEAN': "estimates.firstFiscalYear.ratios.priceSales.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICESALES.MEAN': "-estimates.firstFiscalYear.ratios.priceSales.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICEEARNINGS.MEAN': "estimates.firstFiscalYear.ratios.priceEarnings.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICEEARNINGS.MEAN': "-estimates.firstFiscalYear.ratios.priceEarnings.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICEEARNINGSGROWTH.MEAN': "estimates.firstFiscalYear.ratios.priceEarningsGrowth.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICEEARNINGSGROWTH.MEAN': "-estimates.firstFiscalYear.ratios.priceEarningsGrowth.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICEBOOKVALUE.MEAN': "estimates.firstFiscalYear.ratios.priceBookValue.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICEBOOKVALUE.MEAN': "-estimates.firstFiscalYear.ratios.priceBookValue.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICECASHFLOW.MEAN': "estimates.firstFiscalYear.ratios.priceCashFlow.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICECASHFLOW.MEAN': "-estimates.firstFiscalYear.ratios.priceCashFlow.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICEFREECASHFLOW.MEAN': "estimates.firstFiscalYear.ratios.priceFreeCashFlow.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.PRICEFREECASHFLOW.MEAN': "-estimates.firstFiscalYear.ratios.priceFreeCashFlow.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.DIVIDENDYIELD.MEAN': "estimates.firstFiscalYear.ratios.dividendYield.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.DIVIDENDYIELD.MEAN': "-estimates.firstFiscalYear.ratios.dividendYield.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT.MEAN': "estimates.firstFiscalYear.ratios.enterpriseValueEbit.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT.MEAN': "-estimates.firstFiscalYear.ratios.enterpriseValueEbit.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA.MEAN': "estimates.firstFiscalYear.ratios.enterpriseValueEbitda.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA.MEAN': "-estimates.firstFiscalYear.ratios.enterpriseValueEbitda.mean",
            'ESTIMATES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUESALES.MEAN': "estimates.firstFiscalYear.ratios.enterpriseValueSales.mean",
            '-ESTIMATES.FIRSTFISCALYEAR.RATIOS.ENTERPRISEVALUESALES.MEAN': "-estimates.firstFiscalYear.ratios.enterpriseValueSales.mean",
            'ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.CURRENCY.ISOCODE': "estimates.secondFiscalYear.currencyDependentEstimates.currency.isoCode",
            '-ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.CURRENCY.ISOCODE': "-estimates.secondFiscalYear.currencyDependentEstimates.currency.isoCode",
            'ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBIT.MEAN': "estimates.secondFiscalYear.currencyDependentEstimates.ebit.mean",
            '-ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBIT.MEAN': "-estimates.secondFiscalYear.currencyDependentEstimates.ebit.mean",
            'ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBITDA.MEAN': "estimates.secondFiscalYear.currencyDependentEstimates.ebitda.mean",
            '-ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBITDA.MEAN': "-estimates.secondFiscalYear.currencyDependentEstimates.ebitda.mean",
            'ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.SALES.MEAN': "estimates.secondFiscalYear.currencyDependentEstimates.perShare.sales.mean",
            '-ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.SALES.MEAN': "-estimates.secondFiscalYear.currencyDependentEstimates.perShare.sales.mean",
            'ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.EARNINGS.MEAN': "estimates.secondFiscalYear.currencyDependentEstimates.perShare.earnings.mean",
            '-ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.EARNINGS.MEAN': "-estimates.secondFiscalYear.currencyDependentEstimates.perShare.earnings.mean",
            'ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.DIVIDENDS.MEAN': "estimates.secondFiscalYear.currencyDependentEstimates.perShare.dividends.mean",
            '-ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.DIVIDENDS.MEAN': "-estimates.secondFiscalYear.currencyDependentEstimates.perShare.dividends.mean",
            'ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.CASHFLOW.MEAN': "estimates.secondFiscalYear.currencyDependentEstimates.perShare.cashFlow.mean",
            '-ESTIMATES.SECONDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.CASHFLOW.MEAN': "-estimates.secondFiscalYear.currencyDependentEstimates.perShare.cashFlow.mean",
            'ESTIMATES.SECONDFISCALYEAR.RETURNONASSETS.MEAN': "estimates.secondFiscalYear.returnOnAssets.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RETURNONASSETS.MEAN': "-estimates.secondFiscalYear.returnOnAssets.mean",
            'ESTIMATES.SECONDFISCALYEAR.RETURNONEQUITY.MEAN': "estimates.secondFiscalYear.returnOnEquity.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RETURNONEQUITY.MEAN': "-estimates.secondFiscalYear.returnOnEquity.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICESALES.MEAN': "estimates.secondFiscalYear.ratios.priceSales.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICESALES.MEAN': "-estimates.secondFiscalYear.ratios.priceSales.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICEEARNINGS.MEAN': "estimates.secondFiscalYear.ratios.priceEarnings.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICEEARNINGS.MEAN': "-estimates.secondFiscalYear.ratios.priceEarnings.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICEEARNINGSGROWTH.MEAN': "estimates.secondFiscalYear.ratios.priceEarningsGrowth.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICEEARNINGSGROWTH.MEAN': "-estimates.secondFiscalYear.ratios.priceEarningsGrowth.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICEBOOKVALUE.MEAN': "estimates.secondFiscalYear.ratios.priceBookValue.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICEBOOKVALUE.MEAN': "-estimates.secondFiscalYear.ratios.priceBookValue.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICECASHFLOW.MEAN': "estimates.secondFiscalYear.ratios.priceCashFlow.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICECASHFLOW.MEAN': "-estimates.secondFiscalYear.ratios.priceCashFlow.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICEFREECASHFLOW.MEAN': "estimates.secondFiscalYear.ratios.priceFreeCashFlow.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.PRICEFREECASHFLOW.MEAN': "-estimates.secondFiscalYear.ratios.priceFreeCashFlow.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.DIVIDENDYIELD.MEAN': "estimates.secondFiscalYear.ratios.dividendYield.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.DIVIDENDYIELD.MEAN': "-estimates.secondFiscalYear.ratios.dividendYield.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT.MEAN': "estimates.secondFiscalYear.ratios.enterpriseValueEbit.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT.MEAN': "-estimates.secondFiscalYear.ratios.enterpriseValueEbit.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA.MEAN': "estimates.secondFiscalYear.ratios.enterpriseValueEbitda.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA.MEAN': "-estimates.secondFiscalYear.ratios.enterpriseValueEbitda.mean",
            'ESTIMATES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUESALES.MEAN': "estimates.secondFiscalYear.ratios.enterpriseValueSales.mean",
            '-ESTIMATES.SECONDFISCALYEAR.RATIOS.ENTERPRISEVALUESALES.MEAN': "-estimates.secondFiscalYear.ratios.enterpriseValueSales.mean",
            'ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.CURRENCY.ISOCODE': "estimates.thirdFiscalYear.currencyDependentEstimates.currency.isoCode",
            '-ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.CURRENCY.ISOCODE': "-estimates.thirdFiscalYear.currencyDependentEstimates.currency.isoCode",
            'ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBIT.MEAN': "estimates.thirdFiscalYear.currencyDependentEstimates.ebit.mean",
            '-ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBIT.MEAN': "-estimates.thirdFiscalYear.currencyDependentEstimates.ebit.mean",
            'ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBITDA.MEAN': "estimates.thirdFiscalYear.currencyDependentEstimates.ebitda.mean",
            '-ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.EBITDA.MEAN': "-estimates.thirdFiscalYear.currencyDependentEstimates.ebitda.mean",
            'ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.SALES.MEAN': "estimates.thirdFiscalYear.currencyDependentEstimates.perShare.sales.mean",
            '-ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.SALES.MEAN': "-estimates.thirdFiscalYear.currencyDependentEstimates.perShare.sales.mean",
            'ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.EARNINGS.MEAN': "estimates.thirdFiscalYear.currencyDependentEstimates.perShare.earnings.mean",
            '-ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.EARNINGS.MEAN': "-estimates.thirdFiscalYear.currencyDependentEstimates.perShare.earnings.mean",
            'ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.DIVIDENDS.MEAN': "estimates.thirdFiscalYear.currencyDependentEstimates.perShare.dividends.mean",
            '-ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.DIVIDENDS.MEAN': "-estimates.thirdFiscalYear.currencyDependentEstimates.perShare.dividends.mean",
            'ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.CASHFLOW.MEAN': "estimates.thirdFiscalYear.currencyDependentEstimates.perShare.cashFlow.mean",
            '-ESTIMATES.THIRDFISCALYEAR.CURRENCYDEPENDENTESTIMATES.PERSHARE.CASHFLOW.MEAN': "-estimates.thirdFiscalYear.currencyDependentEstimates.perShare.cashFlow.mean",
            'ESTIMATES.THIRDFISCALYEAR.RETURNONASSETS.MEAN': "estimates.thirdFiscalYear.returnOnAssets.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RETURNONASSETS.MEAN': "-estimates.thirdFiscalYear.returnOnAssets.mean",
            'ESTIMATES.THIRDFISCALYEAR.RETURNONEQUITY.MEAN': "estimates.thirdFiscalYear.returnOnEquity.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RETURNONEQUITY.MEAN': "-estimates.thirdFiscalYear.returnOnEquity.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICESALES.MEAN': "estimates.thirdFiscalYear.ratios.priceSales.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICESALES.MEAN': "-estimates.thirdFiscalYear.ratios.priceSales.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICEEARNINGS.MEAN': "estimates.thirdFiscalYear.ratios.priceEarnings.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICEEARNINGS.MEAN': "-estimates.thirdFiscalYear.ratios.priceEarnings.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICEEARNINGSGROWTH.MEAN': "estimates.thirdFiscalYear.ratios.priceEarningsGrowth.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICEEARNINGSGROWTH.MEAN': "-estimates.thirdFiscalYear.ratios.priceEarningsGrowth.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICEBOOKVALUE.MEAN': "estimates.thirdFiscalYear.ratios.priceBookValue.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICEBOOKVALUE.MEAN': "-estimates.thirdFiscalYear.ratios.priceBookValue.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICECASHFLOW.MEAN': "estimates.thirdFiscalYear.ratios.priceCashFlow.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICECASHFLOW.MEAN': "-estimates.thirdFiscalYear.ratios.priceCashFlow.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICEFREECASHFLOW.MEAN': "estimates.thirdFiscalYear.ratios.priceFreeCashFlow.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.PRICEFREECASHFLOW.MEAN': "-estimates.thirdFiscalYear.ratios.priceFreeCashFlow.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.DIVIDENDYIELD.MEAN': "estimates.thirdFiscalYear.ratios.dividendYield.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.DIVIDENDYIELD.MEAN': "-estimates.thirdFiscalYear.ratios.dividendYield.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT.MEAN': "estimates.thirdFiscalYear.ratios.enterpriseValueEbit.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBIT.MEAN': "-estimates.thirdFiscalYear.ratios.enterpriseValueEbit.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA.MEAN': "estimates.thirdFiscalYear.ratios.enterpriseValueEbitda.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUEEBITDA.MEAN': "-estimates.thirdFiscalYear.ratios.enterpriseValueEbitda.mean",
            'ESTIMATES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUESALES.MEAN': "estimates.thirdFiscalYear.ratios.enterpriseValueSales.mean",
            '-ESTIMATES.THIRDFISCALYEAR.RATIOS.ENTERPRISEVALUESALES.MEAN': "-estimates.thirdFiscalYear.ratios.enterpriseValueSales.mean",


        },
    }

    validations = {
        ('sort',): {
            'max_items': 10,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'attributes': (AttributesMember,),  # noqa: E501
            'language': (LanguageMember,),  # noqa: E501
            'sort': ([str],),  # noqa: E501
            'pagination': (PostStockNotationScreenerSearchRequestMetaPagination,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'attributes': 'attributes',  # noqa: E501
        'language': 'language',  # noqa: E501
        'sort': 'sort',  # noqa: E501
        'pagination': 'pagination',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """PostStockNotationScreenerSearchRequestMeta - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            attributes (AttributesMember): [optional]  # noqa: E501
            language (LanguageMember): [optional]  # noqa: E501
            sort ([str]): Sortable attributes. The sort order is ascending unless it is prefixed with a minus sign, in which case it is descending. A list of at most 10 (possibly prefixed) attribute name(s) is allowed.. [optional] if omitted the server will use the default value of ["inSortEnumument.name"]  # noqa: E501
            pagination (PostStockNotationScreenerSearchRequestMetaPagination): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """PostStockNotationScreenerSearchRequestMeta - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            attributes (AttributesMember): [optional]  # noqa: E501
            language (LanguageMember): [optional]  # noqa: E501
            sort ([str]): Sortable attributes. The sort order is ascending unless it is prefixed with a minus sign, in which case it is descending. A list of at most 10 (possibly prefixed) attribute name(s) is allowed.. [optional] if omitted the server will use the default value of ["inSortEnumument.name"]  # noqa: E501
            pagination (PostStockNotationScreenerSearchRequestMetaPagination): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
